/*
 * Read/write minefield data
 * part of the host-toolkit package
 */

#include <stdio.h>
#include "tkhost.h"
#include "tkh.h"
#include "tkiocomm.h"

MINEDATA *read_minedata(int mnum)
{
  FILE *handle;
  MINEDATA *str;

  handle=mkopen("mines.hst",true,'r');
  if (!handle) return NULL;

  if (mnum>500 || mnum<1) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,12*(mnum-1),SEEK_SET);

  str=new MINEDATA;
  if (!str) {
    fclose(handle);
    return NULL;
  }

  str->pos.x=readUB2(handle);
  str->pos.y=readUB2(handle);
  str->wRace=readUB2(handle);
  str->lUnits=readUB4(handle);
  str->wWeb=readUB2(handle);

  fclose(handle);
  return str;
}

MINEDATA *read_all_minedata()
{
  FILE *handle;
  MINEDATA *str;
  int mnum;

  handle=mkopen("mines.hst",true,'r');
  if (!handle) return NULL;

  str=new MINEDATA [501];
  if (!str) {
    fclose(handle);
    return NULL;
  }

  for(mnum=1;mnum<=500;mnum++) {
    str[mnum].pos.x=readUB2(handle);
    str[mnum].pos.y=readUB2(handle);
    str[mnum].wRace=readUB2(handle);
    str[mnum].lUnits=readUB4(handle);
    str[mnum].wWeb=readUB2(handle);
  }

  fclose(handle);
  return str;
}

bool write_minedata(int mnum,MINEDATA *str)
{
  FILE *handle;
  bool v;

  handle=mkopen("mines.hst",false,'w');
  if (!handle) return false;

  if (mnum>500 || mnum<1) {
    fclose(handle);
    return false;
  }

  fseek(handle,12*(mnum-1),SEEK_SET);

  v=writeUB2(handle,str->pos.x);
  if (v) v=writeUB2(handle,str->pos.y);
  if (v) v=writeUB2(handle,str->wRace);
  if (v) v=writeUB4(handle,str->lUnits);
  if (v) v=writeUB2(handle,str->wWeb);

  fclose(handle);
  return v;
}
