/*
 * Write checksums for ships, planets and bases
 * part of the Player-Toolkit package
 */

#include <stdio.h>
#include "tkplayer.h"
#include "tkp.h"
#include "tkiocomm.h"

void make_cs(FILE *genha,FILE *conha,FILE *fizha,long genoff,long conoff,const char *fnbase,int rsize,int idoff,int fboff,UB4 fbdelta)
{
  UB4 localcs;
  UB4 globalcs;
  UB2 recs,ctr;
  UB1 v;
  int k,id=0;
  XString fn;
  FILE *dha;
  size_t pos,flen;

  fn=fnbase;
  fn |= "&p.dat";
  dha=mkopen((const char *)fn,false,'r');
  fseek(dha,0,SEEK_END);
  flen=ftell(dha);
  fseek(dha,0,SEEK_SET);

  recs=readUB2(dha);
  globalcs= (recs & 0xFF) + (recs >> 8);

  for (ctr=0;ctr<recs;ctr++) {
    localcs=0;
    for (k=0;k<rsize;k++) {
      v=readUB1(dha);
      localcs += v;
      if (idoff==k) id=v;
      if (idoff+1==k) id += v*256;
    }
    fseek(conha,conoff+4*(id-1),SEEK_SET);
    writeUB4(conha,localcs);
    globalcs+=localcs;
  }
  pos=ftell(dha);
  if (pos<flen) {
    for(;pos<flen;pos++) {
      globalcs+=readUB1(dha);
    }
  }

  fclose(dha);

  fn=fnbase;
  fn |= "&p.dis";
  dha=mkopen((const char *)fn,false,'r');
  fseek(dha,0,SEEK_END);
  flen=ftell(dha);
  fseek(dha,0,SEEK_SET);

  recs=readUB2(dha);
  globalcs+=(recs & 0xFF) + (recs >> 8);

  for (ctr=0;ctr<recs;ctr++) {
    for (k=0;k<rsize;k++) {
      globalcs += readUB1(dha);
    }
  }
  pos=ftell(dha);
  if (pos<flen) {
    for(;pos<flen;pos++) {
      globalcs+=readUB1(dha);
    }
  }

  fclose(dha);

  fseek(genha,genoff,SEEK_SET);
  writeUB4(genha,globalcs);

  globalcs+=fbdelta;
  fseek(fizha,fboff+(playernum-1)*12,SEEK_SET);
  writeUB4(fizha,globalcs);
}

void make_checksum(bool ships,bool planets,bool bases)
{
  FILE *genha,*conha,*fizha;

  genha=mkopen("gen&p.dat",false,'w');
  conha=mkopen("control.dat",false,'w');
  fizha=mkopen("fizz.bin",false,'w');
  if (ships) {
    make_cs(genha,conha,fizha,0x81,0,"ship",107,0,0,667);
  }
  if (planets) {
    make_cs(genha,conha,fizha,0x85,2000,"pdata",85,2,4,1667);
  }
  if (bases) {
    make_cs(genha,conha,fizha,0x89,4000,"bdata",156,0,8,1262);
  }
  fclose(genha);
  fclose(conha);
  fclose(fizha);
}

