/*
 * Read ion storm data
 * part of the Player-Toolkit library
 */

#include <stdio.h>
#include "tkplayer.h"
#include "tkp.h"
#include "tkiocomm.h"

ION_NAME *read_ion_name(int inum)
{
  FILE *handle;
  ION_NAME *str;

  handle=mkopen("storm.nm",true,'r');
  if (!handle) return NULL;

  if (inum>50 || inum<1) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,20*(inum-1),SEEK_SET);

  str=new ION_NAME;
  if (!str) {
    fclose(handle);
    return NULL;
  }

  str->sName=readXString(handle,20);

  fclose(handle);
  return str;
}

ION_NAME *read_all_ion_name()
{
  FILE *handle;
  ION_NAME *str;
  int inum;

  handle=mkopen("storm.nm",true,'r');
  if (!handle) return NULL;

  str=new ION_NAME [51];

  for (inum=1;inum<=50;inum++) {
    str[inum].sName=readXString(handle,20);
  }

  fclose(handle);
  return str;
}
